// Copyright 2018 by Robert Dick.
// All rights reserved.

#include "RStd.h"
#include "Geom.h"
#include "Epsilon.h"

namespace rstd {
using namespace std;

/*###########################################################################*/
void Geom_test() {
	PRect<2, int> a(Pos<2, int>(6, 8), Rect<2, int>(6, 2));
	PRect<2, int> b(Pos<2, int>(2, -8), Rect<2, int>(4, 8));

	a.make_bbox(b);
	cout << "from Geom.cc" << endl;
	cout << a << "\n";

	Rect<2, double, eps_comp_obj<double> > k(1.0, 1.0);

	Rassert(a != b);

	PRect<2, int> c(Pos<2, int>(1, 1), Rect<2, int>(2, 2));
	PRect<2, int> d(Pos<2, int>(2, 2), Rect<2, int>(4, 4));
	cout << "@@@" << c.area_intersect(d) << endl;
	cout << "***" << c.intersect(d) << endl;
	cout << "###" << c.pos_intersect(d) << endl;

	PRect<2, int> e(Pos<2, int>(1, 1), Rect<2, int>(2, 2));
	PRect<2, int> f(Pos<2, int>(2, 2), Rect<2, int>(2, 2));
	cout << "***" << e.intersect(f) << endl;

	PRect<2, int> h(Pos<2, int>(2, 2), Rect<2, int>(2, 2));
	PRect<2, int> i(Pos<2, int>(3, 3), Rect<2, int>(8, 8));
	cout << "***" << h.intersect(i) << endl;

	PRect<2, double> j(Pos<2, double>(0.00019375, 0.00019375), Rect<2, double>(0.0003875, 0.0003875));
	PRect<2, double> l(Pos<2, double>(0.00155, 0.00155), Rect<2, double>(0.0031, 0.0031));
	cout << "****" << j.intersect(l) << endl;

	FVector<2, double> * base = new Rect<2, double>(0.0, 0.0);
	Rect<2, double> * derived = dynamic_cast<Rect<2, double> *>(base);

	Rdump(base);
	Rdump(*base);
	Rdump(derived);
	Rdump(*derived);

	delete base;
}

}
