// Copyright 2018 by Robert Dick.
// All rights reserved.

#ifndef MST_H_
#define MST_H_

/*###########################################################################*/
// Minimal spanning tree.

#include "RVector.h"
#include "Geom.h"

#include <utility>
#include <limits>

namespace rstd {
template <typename> class RVector;

/*###########################################################################*/
// Minimal spanning tree computation.

template <int DIM, typename NUM,
typename DIST_FUNC = NUM (*)(const Pos<DIM, NUM> &, const Pos<DIM, NUM> &)>
class MST {
public:
// Location.
	virtual ~MST() {}

// Takes iterators to container of Positions (Pos).
	template <typename ITER>
		MST(DIST_FUNC dist_func, ITER place_begin, ITER place_end);

// Total connection length.
	double total_len() const { return total_len_; }

private:
		double total_len_;
};

void MST_test();

/*###########################################################################*/
#include "MST.cct"
}
#endif
