// Copyright 2018 by Robert Dick.
// All rights reserved.

#include "Graph.h"

#include <iostream>
//#include <stdlib>

using namespace rstd; 
using namespace std;

void graphGen(RawGraph &g, int level, int vertexNum, int edgeNum) {

	typedef RawGraph::vertex_index vi;

	RVector<RawGraph::vertex_index> dl;

	int vn_left = vertexNum;
	int en_left = edgeNum;
	int vn_current = 0;
	int en_current = 0;

	MAP(x,level) {

		// determine the number of vertex for each level
		if (x < level - 1) {
			vn_current = (random()/RAND_MAX)*vn_left;
		}
		else {
			vn_current = vn_left;
		}

		// generate vertex for each level
		MAP(y, vn_current) {
			vi v = g.add_vertex();
			dl.push_back(v);
		}

		// generate edge between different level
		if (x > 0) {

			if (x < level - 1) {
				en_current = (random()/RAND_MAX)*en_left;
			}
			else {
				en_current = en_left;
			}

			MAP(z, en_current) {
				vi from = dl[int((random()/RAND_MAX)*(vertexNum-vn_left))];
				vi to = dl[int((random()/RAND_MAX)*vn_current
					+ (vertexNum-vn_left))];
				g.add_edge(from,to);
			}
		}

		vn_left -= vn_current;
		en_left -= en_current;
	}

}




int main(int argc, char * argv[]) {


	int level, vertexNum, edgeNum;
	
	switch(argc) {
	case 4 :
		level = atoi(argv[1]);
		vertexNum = atoi(argv[2]);
		edgeNum = atoi(argv[3]);
		break;
	default:
		cout << "incorrect usage" << "\n";
		cout << "GraphGen #level #vertexNum #edgeNum" << "\n";
		return -1;
	}

	cout << "step 0\n";
	RawGraph g;
	cout << "step 1\n";
	graphGen(g,level,vertexNum,edgeNum);
	
}
