// Copyright 2018 by Robert Dick.
// All rights reserved.

#include <stdlib.h>
#include <stdio.h>

#include "rstd.h"

/*###########################################################################*/
void rexit(const char *s) {
	printf(s);
	exit(EXIT_SUCCESS);
}

/*===========================================================================*/
void rpos_(const char *file, int line) {
	printf("File: %s Line: %d\n", file, line);
}

/*===========================================================================*/
void rabort_(const char *file, int line) {
	printf("Program aborted.\n");
	rpos_(file, line);
	abort();
}

/*===========================================================================*/
void rassert_(int x, const char *file, int line) {
	if (! x) {
		printf("Assertion failure.\n");
		rpos_(file, line);
		abort();
	}
}

/*###########################################################################*/
#ifdef ROB_DEBUG
int rob_debug_ = 1;
#endif
